package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.TestCaidan;
import com.izouma.awesomeadmin.service.TestCaidanService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/testCaidan")
public class TestCaidanController {

    @Autowired
    private TestCaidanService testCaidanService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(TestCaidan record) {
        List<TestCaidan> pp = testCaidanService.getTestCaidanList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getTestCaidan", method = RequestMethod.GET)
    @ResponseBody
    public Result getTestCaidan(@RequestParam(required = false, value = "id") String id) {
        TestCaidan data = testCaidanService.getTestCaidanById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(TestCaidan record) {
        TestCaidan data = testCaidanService.getTestCaidan(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, TestCaidan record) {
        Map<String, Object> result = new HashMap<>();

        List<TestCaidan> pp =testCaidanService.getTestCaidanByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(TestCaidan record) {
        boolean num = testCaidanService.createTestCaidan(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateTestCaidan(TestCaidan record) {
        boolean num = testCaidanService.updateTestCaidan(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteTestCaidan(@RequestParam(required = true, value = "id") String id) {

        boolean num = testCaidanService.deleteTestCaidan(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, TestCaidan record) throws Exception {

    List<TestCaidan> testCaidans = testCaidanService.getTestCaidanList(record);


        String sheetName = "CaiDan_Table";
        String titleName = "caidan数据表";
        String fileName = "caidan表";
        int columnNumber = 7;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "SequenceID" ,   "ID" ,   "CaiDanXiangMing" ,   "CaiDanCiXu" ,   "URL" ,   "CaiDanShuoMing" ,   "ChuFaTiaoJian"  };
        String[][] dataList = new String[testCaidans.size()][7];

        for (int i = 0; i < testCaidans.size(); i++) {

                        dataList[i][0] = String.valueOf(testCaidans.get(i).getSequenceid());
                        dataList[i][1] = String.valueOf(testCaidans.get(i).getId());
                        dataList[i][2] = String.valueOf(testCaidans.get(i).getCaidanxiangming());
                        dataList[i][3] = String.valueOf(testCaidans.get(i).getCaidancixu());
                        dataList[i][4] = String.valueOf(testCaidans.get(i).getUrl());
                        dataList[i][5] = String.valueOf(testCaidans.get(i).getCaidanshuoming());
                        dataList[i][6] = String.valueOf(testCaidans.get(i).getChufatiaojian());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

